.TH DCOPY 3 "11 March 1978" "Version 1.00"
.\" WARNING: This file was produced automatically from file common/dcopy.f
.\" by fortran-to-man-page.awk on Mon Jan 22 10:36:36 MST 2001.
.\" Any manual changes will be lost if this file is regenerated!
.SH NAME
dcopy \- Double-precision vector copy
.\"=====================================================================
.SH SYNOPSIS
Fortran (77, 90, 95, HPF):
.RS
.B f77
.I "[ flags ] file(s) .\|.\|. -L/usr/local/lib -lgjl"
.RS
.nf
.B "SUBROUTINE dcopy(n,dx,incx,dy,incy)"
.B "DOUBLE PRECISION    dx(*),       dy(*)"
.B "INTEGER             incx,        incy,        n"
.fi
.RE
.RE
C (K&R, 89, 99), C++ (98):
.RS
.B cc
.I "[ flags ] -I/usr/local/include file(s) .\|.\|. -L/usr/local/lib -lgjl"
.br
Use
.RS
.B "#include <gjl.h>"
.RE
to get this prototype:
.RS
.B "void dcopy(const fortran_integer * n_,"
.B "           fortran_double_precision dx_[],"
.B "           const fortran_integer * incx_,"
.B "           fortran_double_precision dy_[],"
.B "           const fortran_integer * incy_);"
.RE
.RE
.PP
NB: The definition of C/C++ data types
.B fortran_
.IR xxx ,
and the mapping of Fortran external names to C/C++ external names,
is handled by the C/C++ header file.  That way, the same function
or subroutine name can be used in C, C++, and Fortran code,
independent of compiler conventions for mangling of external
names in these programming languages.
.PP
Last code modification: 11-Mar-1978
.\"=====================================================================
.SH DESCRIPTION
Copy \fBn\fP\& elements of a vector \fBdx\fP\&(*) to a vector \fBdy\fP\&(*), starting at
index 1, and then stepping with increments \fBincx\fP\& and \fBincy\fP\&,
respectively.
.PP
Use unrolled loops for increments equal to one.
.PP
This is a LINPACK BLAS Level 1 primitive, with revised header
comments.
.\"=====================================================================
.SH AUTHORS
The algorithms and code are described in detail in
the paper
.RS
.I "Algorithm xxx: Quadruple-Precision Gamma(x) and psi(x) Functions for Real Arguments"
.RE
in ACM Transactions on Mathematical Software,
Volume ??, Number ??, Pages ????--???? and
????--????, 2001, by
.RS
.nf
Nelson H. F. Beebe
Center for Scientific Computing
University of Utah
Department of Mathematics, 110 LCB
155 S 1400 E RM 233
Salt Lake City, UT 84112-0090
Tel: +1 801 581 5254
FAX: +1 801 581 4148
Email: \fCbeebe@math.utah.edu\fP, \fCbeebe@acm.org\fP, \fCbeebe@computer.org\fP
WWW URL: \fChttp://www.math.utah.edu/~beebe\fP
.fi
.RE
and
.RS
.nf
James S. Ball
University of Utah
Department of Physics
Salt Lake City, UT 84112-0830
USA
Tel: +1 801 581 8397
FAX: +1 801 581 6256
Email: \fCball@physics.utah.edu\fP
WWW URL: \fChttp://www.physics.utah.edu/people/faculty/ball.html\fP
.fi
.RE
.\"==============================[The End]==============================
.\"=====================================================================
.\" This is for GNU Emacs file-specific customization:
.\" Local Variables:
.\" fill-column: 50
.\" End:
